proc(6) = cdtest(e,n,tivec,starttvec,endtvec);

local cumtivec, T_rho, T_rho2_1, i, e_i, startt_i, endt_i, j, e_j, startt_j, endt_j;
local t_s, t_e, e_i_t, e_j_t, T_rho_ij, cd_nt, cd_lm, pvalue_cd_nt, pvalue_cd_lm;
local disc,T_ij,T_ij_v,used,meanrho,rho,rho_ij;
cumtivec=0|cumsumc(tivec);
/** NOTE: When T_ij<4, rho_ij is not calculable, so need to be discarded ***/
/******** To obtain Pesaran (2003) test  (CD_nt) ******/
rho = 0;	/** for CD_nt ***/
T_rho=0;
T_rho2_1=0;	/** for CD_lm ***/
disc=0; /** discarded pair for T_ij<4 **/
/** for corrected CD_lm ***/
	i=1;
	do while i<=n-1;
		e_i=e[cumtivec[i]+1:cumtivec[i+1]];
		startt_i=starttvec[i];
		endt_i=endtvec[i];
			j=i+1;
    	do while j<=N;

				e_j=e[cumtivec[j]+1:cumtivec[j+1]];
				startt_j=starttvec[j];
				endt_j=endtvec[j];

/*** To eliminate T_ij<4 ***/
        if startt_i<=startt_j and endt_i>=startt_j;
            T_ij=endt_i - startt_j - (endt_i-endt_j)*(endt_i>endt_j) +1;
            elseif startt_i>=startt_j and endt_i<=startt_j;
                T_ij=endt_j - startt_i - (endt_j-endt_i)*(endt_j>endt_i) +1;
            else; T_ij=0;
        endif;
        if T_ij<4;j=j+1;disc=disc+1;goto DISCARD;endif;
/***** end of the elimination procedure ****/
				t_s=maxc(startt_i|startt_j);
				t_e=minc(endt_i|endt_j);

				e_i_t = e_i[t_s-startt_i+1:t_e-startt_i+1];
				e_j_t = e_j[t_s-startt_j+1:t_e-startt_j+1];
				
                rho_ij=(e_i_t'e_j_t)/(sqrt(e_i_t'e_i_t)*sqrt(e_j_t'e_j_t));
				T_rho_ij = sqrt(rows(e_i_t))*rho_ij;
              
                rho=rho+rho_ij;      
				T_rho = T_rho + T_rho_ij ;   			/*  for CD_nt */
				T_rho2_1 = T_rho2_1  + (T_rho_ij^2 - 1);/*  for CD_lm */

			j=j+1;
DISCARD:
			endo;
		i=i+1;
	endo;
CD_nt = sqrt(1/((n*(n-1)/2)-disc))*T_rho;
CD_lm = sqrt(1/(2*((n*(n-1)/2)-disc)))*T_rho2_1;
meanrho=rho/((n*(n-1)/2)-disc);

pvalue_CD_nt = 2*cdfnc(abs(CD_nt)); /** two sided!!*/
pvalue_cd_lm = 2*cdfnc(abs(CD_lm));

used=((n*(n-1)/2)-disc)/(n*(n-1)/2);

retp(cd_nt,cd_lm,pvalue_cd_nt,pvalue_cd_lm,used,meanrho);
endp;