   /**** Pooled CCE ****/
proc(10)=pcce5(varname_cce,y, x, h, n,tivec,starttvec,endtvec,years,sig_cce,b_vec_mg);

local cumtivec, mx_mx, mx_y, i, y_i, x_i, h_i, m_h_i, mx_i;
local b_pcce, e_pcce,sig2_pcce,cov_pcce,se_pcce,tvalue_pcce,se_pccer,tvalue_pccer;
local omega_h,e_pcce_i,cov_pcce_rbst_h,se_pcce_rbst_h,tvalue_pcce_rbst_h;
local omega,cov_pcce_rbst,se_pcce_rbst,tvalue_pcce_rbst,out_pcce,sig_i_vec;
local namedep,namevar_pcce,results_pcce,st_results_pcce,nameh;
local m_i,dof_i,b_mg,b_dm,sig_mg,sig2_mg,cov_mg,se_mg,tvalue_mg,ci_vec;
local results_mg,st_results_mg,out_mg,MGexcel,st_st,testname,c,testi,testst;
local varnames, namev,string_resultvec, ytoy,ttest05,ttest10,ttest20,k;
local se_ci,var_ci,tvalue_ci,namevar_h,estvec,mean,medi,sd,m2,m3,m4;
local skew,kurtosis,resultvec,statsname,varnames2;
local startyear,endyear;
local omega_h_pcce,omega_h_mgcce,omega_nw,cov_pcce_rbst_h_mg,cov_pcce_rbst_nw;
local lg,omega_h_i,z_i,z_i_bar,gama0,gamas,s,omega_hs,cov_pcce_hs,iv_mx_mx;
local omega_hs2,cov_pcce_hs2,omega_hs3,cov_pcce_hs3,b_mean;

cumtivec=0|cumsumc(tivec);
mx_mx=zeros(cols(x),cols(x)); /** sum of (mx_i'mx_i) **/
mx_y=zeros(cols(x),1);		   /** sum of (mx_i'y_i)    **/
omega_h=zeros(cols(x),cols(x));
iv_mx_mx=zeros(cols(x),cols(x));
	i=1;
	do while i<=n;
		y_i=y[cumtivec[i]+1:cumtivec[i+1]];
			x_i=x[cumtivec[i]+1:cumtivec[i+1],.];
			h_i=h[cumtivec[i]+1:cumtivec[i+1],.];
		m_h_i=(eye(tivec[i])-h_i*pinv(h_i'h_i)*h_i');
		mx_i=m_h_i*x_i;
		mx_mx = mx_mx + mx_i'mx_i;
        iv_mx_mx=iv_mx_mx+(sig_cce[i]^2)*pinv(mx_i'mx_i);
        /*omega_h=omega_h + (sig_cce[i]^2)*mx_i'mx_i;*/
		mx_y = mx_y + mx_i'y_i;
		
   			if i==1;
				startyear=years[starttvec[i]];
				endyear=years[endtvec[i]];
					else;
						startyear=startyear|years[starttvec[i]];
						endyear=endyear|years[endtvec[i]];
			endif;

		i=i+1;
	endo;

/** beta hat PCCE **/
b_pcce =pinv(mx_mx)*mx_y;



/** residuals & coefficients on Hi **/
	i=1;sig_i_vec=zeros(n,1);ci_vec=zeros(n,cols(h));
	do while i<=n;
		y_i=y[cumtivec[i]+1:cumtivec[i+1]];
			x_i=x[cumtivec[i]+1:cumtivec[i+1],.];
			h_i=h[cumtivec[i]+1:cumtivec[i+1],.];
		m_h_i=(eye(tivec[i])-h_i*invpd(h_i'h_i)*h_i');
        ci_vec[i,.]=(inv(h_i'h_i)*h_i'(y_i-x_i*b_pcce))';/**coeffcients on Hi**/

			if i==1;e_pcce=m_h_i*y_i - m_h_i*x_i*b_pcce;
                sig_i_vec[i]=sqrt((m_h_i*y_i - m_h_i*x_i*b_pcce)'(m_h_i*y_i - m_h_i*x_i*b_pcce)/(tivec[i]-cols(h)));

				else;e_pcce=e_pcce|(m_h_i*y_i - m_h_i*x_i*b_pcce);
                dof_i = sumc(diag(m_h_i));
                sig_i_vec[i]=
                sqrt((m_h_i*y_i - m_h_i*x_i*b_pcce)'(m_h_i*y_i - m_h_i*x_i*b_pcce)/(tivec[i]-cols(h)));
        
			endif;
		i=i+1;
	endo;
sig2_pcce=e_pcce'e_pcce/(sumc(tivec)-n*cols(h)-cols(x_i));
cov_pcce=sig2_pcce*(inv(mx_mx));
se_pcce=sqrt(diag(cov_pcce));
tvalue_pcce=b_pcce./se_pcce;

/** Individual t-test for coefficients on Hi **/
ttest05=zeros(1,cols(h));
ttest10=zeros(1,cols(h));
ttest20=zeros(1,cols(h));
/*
	i=1;
	do while i<=n;
		y_i=y[cumtivec[i]+1:cumtivec[i+1]];
			x_i=x[cumtivec[i]+1:cumtivec[i+1],.];
			h_i=h[cumtivec[i]+1:cumtivec[i+1],.];
		m_h_i=(eye(tivec[i])-h_i*invpd(h_i'h_i)*h_i');
        var_ci = sig2_pcce*inv(h_i'h_i)
                   -invpd(h_i'h_i)*h_i'x_i*cov_pcce*x_i'h_i*invpd(h_i'h_i);
        se_ci=sqrt(diag(var_ci));

			tvalue_ci=abs(ci_vec[i,.]./se_ci');*/ /** absolute t-value **/
            
			/** 5% test **//*
			ttest05=ttest05 + (cdftc(tvalue_ci,tivec[i]-cols(x~h)).<(0.05/2)); 
			ttest10=ttest10 + (cdftc(tvalue_ci,tivec[i]-cols(x~h)).<(0.1/2));   
			ttest20=ttest20 + (cdftc(tvalue_ci,tivec[i]-cols(x~h)).<(0.2/2));   

		i=i+1;
	endo;

*/
/** White 1980 hetero robust ***/
omega_h_pcce=zeros(cols(mx_i),cols(mx_i));
omega_hs2=zeros(cols(mx_i),cols(mx_i));/* (6.54) **/
b_mean=meanc(b_vec_mg);
	i=1;
	do while i<=n;
		e_pcce_i=e_pcce[cumtivec[i]+1:cumtivec[i+1]];
			x_i=x[cumtivec[i]+1:cumtivec[i+1],.];
			h_i=h[cumtivec[i]+1:cumtivec[i+1],.];
		m_h_i=(eye(tivec[i])-h_i*invpd(h_i'h_i)*h_i');

		mx_i=m_h_i*x_i;
/*PCCE*/       	omega_h_pcce=omega_h_pcce + (sig_i_vec[i]^2)*mx_i'mx_i;
                  omega_hs2=omega_hs2 
                  + (mx_i'mx_i)*(b_vec_mg[i,.]-b_mean[1:cols(mx_i)]')'
                                (b_vec_mg[i,.]-b_mean[1:cols(mx_i)]')*(mx_i'mx_i);
		i=i+1;
	endo;

cov_pcce_rbst_h = pinv(mx_mx)*omega_h_pcce*pinv(mx_mx);
cov_pcce_hs2 = pinv(mx_mx/n)*(omega_hs2/(n-1))*pinv(mx_mx/n)/n;


se_pcce_rbst_h=sqrt(diag(cov_pcce_rbst_h));
tvalue_pcce_rbst_h=b_pcce./se_pcce_rbst_h;
			
/** Arellano (1987) hetero/aotocorrelation - Robust variance est **/
/*
omega=zeros(cols(mx_i),cols(mx_i));
	i=1;
	do while i<=n;
		e_pcce_i=e_pcce[cumtivec[i]+1:cumtivec[i+1]];
			x_i=x[cumtivec[i]+1:cumtivec[i+1],.];
			h_i=h[cumtivec[i]+1:cumtivec[i+1],.];
		m_h_i=(eye(tivec[i])-h_i*invpd(h_i'h_i)*h_i');
		mx_i=m_h_i*x_i;
				omega=omega + mx_i'e_pcce_i*e_pcce_i'mx_i;
		i=i+1;
	endo;
if rank(omega)<cols(x); 
*/
	/* no arellano's hetero/autocorrelation robust */
	/* output*/
/*
		format /rd 15,7;
		namedep=varname_cce[1];
		namevar_pcce=varname_cce[2:cols(x)+1];
        namevar_h=varname_cce[cols(x)+2:cols(varname_cce')];
		results_pcce=b_pcce~se_pcce~tvalue_pcce
		~se_pcce_rbst_h~tvalue_pcce_rbst_h;
		st_results_pcce=ftocv(results_pcce,7,7);
		nameh=namedep~"coeff"~"se"~"t-value"~"se(hetero)"~"t-value(hetero)";
else;
	cov_pcce_rbst =pinv(mx_mx)*omega*pinv(mx_mx);
	se_pcce_rbst=sqrt(diag(cov_pcce_rbst));
	tvalue_pcce_rbst=b_pcce./se_pcce_rbst;
*/
/*
endif;

*/

/** mg estimator for coeffcients on Hi's **/

b_mg=meanc(ci_vec)';
b_dm=(ci_vec-b_mg);    
sig_mg = meanc(sig_i_vec);
sig2_mg=sig_mg^2;
cov_mg=b_dm'b_dm/(n*(n-1));
se_mg=sqrt(diag(cov_mg));
tvalue_mg=b_mg./se_mg';

estvec=ci_vec~sig_i_vec~tivec;
	/* output*/
		format /rd 15,7;
		namedep=varname_cce[1];
		namevar_pcce=varname_cce[2:rows(varname_cce)];
        namevar_h=varname_cce[cols(x)+2:cols(varname_cce')];
		results_pcce=(b_pcce~se_pcce~tvalue_pcce~
            sqrt(diag(cov_pcce_hs2))~(b_pcce./sqrt(diag(cov_pcce_hs2))))|
                        ((b_mg')~(_dxmiss*zeros(rows(se_mg),2))~se_mg~tvalue_mg');
		st_results_pcce=ftocv(results_pcce,7,7);	
		nameh=namedep~"coeff"~"se"~"t-value"~"se(rob"~"t-value(rob";
/*
endif;

*/
out_pcce= nameh|(namevar_pcce~st_results_pcce);

mean=meanc(estvec)';
medi=median(estvec)';
sd=stdc(estvec)'; 
	m2=meanc((estvec-mean).^2)';
	m3=meanc((estvec-mean).^3)';
	m4=meanc((estvec-mean).^4)';
skew=m3./(sqrt(m2).^3);
kurtosis=m4./(m2.^2);
resultvec=estvec|mean|medi|sd|skew|kurtosis;

 format /rd 11,7;

namev=ftocv(seqa(1,1,n),2,0);
statsname={"mean","median","s.d.","skewness","kurtosis"};
namev=namev|statsname;
string_resultvec=ftocv(resultvec,8,8);
	varnames=""~(namevar_h')~"sig_i"~"Ti";
	varnames2="Start"~"End";
	ytoy=varnames2|(startyear~endyear)|zeros(5,2)*"";
MGexcel= (varnames|(namev~string_resultvec))~ytoy;
st_st=ftocv((se_mg~tvalue_mg')',7,7);
testname="se"|"tvalue"|"t(i)5%"|"t(i)10%"|"t(i)20%";

c=ftocv(((ttest05|ttest10|ttest20)/n)*100,1,1);
testi=0 $+ c $+ "%";
testst = testname~(st_st|testi);

MGexcel=mgexcel|(testst~zeros(rows(testst),cols(mgexcel)-cols(h)-1));

/*$MGexcel;*/
retp(b_pcce,cov_pcce,sig2_pcce,e_pcce,se_pcce,tvalue_pcce,out_pcce,ci_vec,sig_i_vec,
cov_pcce_hs2);

endp;